function varargout = GlobalCubicSurfacenewnew(varargin)
% build up a cubic surface by subdivisionf

format compact
fh = figure('Visible','on','Name','My GUI',...
            'Position',[5,35,800,690]);
set(fh,'WindowButtonMotionFcn',{@wbm})
set(fh,'WindowButtonDownFcn',{@wbd})
set(fh,'WindowButtonUpFcn',{@wbu})        
        
% Initialization tasks.
ah1 = axes('Parent',fh,'Position',[.1 .15 .8 .8]);

pbh1 = uicontrol(fh,'Style','pushbutton',...
    'String','refinement steps = 0',...
    'Position',[150 10 120 20],...
    'Callback',{@stepButton_Callback});

% pbh2 = uicontrol(fh,'Style','pushbutton','String','reset',...
%     'Position',[280 10 70 20],...
%     'Callback',{@resetButton_Callback});

pbh3 = uicontrol(fh,'Style','pushbutton',...
    'String','show sample points',...
    'Position',[150 35 120 20],...
    'Callback',{@addDataButton_Callback});

pbh4 = uicontrol(fh,'Style','pushbutton','String','find P',...
    'Position',[355 10 65 20],...
    'Callback',{@findPButton_Callback});

% pbh5 = uicontrol(fh,'Style','pushbutton','String','cut edge',...
%     'Position',[430 10 70 20],...
%     'Callback',{@cutEdgeButton_Callback});
% 
% pbh6 = uicontrol(fh,'Style','pushbutton','String','moving',...
%     'Position',[510 10 100 20],...
%     'Callback',{@movingButton_Callback});
% 
% pbh7 = uicontrol(fh,'Style','pushbutton','String','Decompose = 0',...
%     'Position',[620 35 100 20],...
%     'Callback',{@decomposeButton_Callback});
% 
% pbh8 = uicontrol(fh,'Style','pushbutton','String','Reconstuct = 0',...
%     'Position',[620 10 100 20],...
%     'Callback',{@reconstuctButton_Callback});


sth1 = uicontrol(fh,'Style','text',...
    'String','Percentage % = ',...
    'Position',[10 10 80 15]);

eth1 = uicontrol(fh,'Style','edit',...
        'String','100',...
        'Position',[90 10 50 20],...
        'Callback',{@edittext1_Callback});
    
sth2 = uicontrol(fh,'Style','text',...
    'String','Mesh Size = ',...
    'Position',[10 35 80 15]);

eth2 = uicontrol(fh,'Style','edit',...
        'String','6',...
        'Position',[90 35 50 20],...
        'Callback',{@edittext2_Callback});

sth3 = uicontrol(fh,'Style','text',...
    'String','(x,y,z)=',...
    'Position',[280 35 250 15]);



%Global variable
meshSize = 6;
percentage = 100;    
steps = 0;
tri=[]; x=[]; y=[]; z=[]; P=[]; w=[]; e=[];
rx=[]; ry=[]; kx=[]; ky=[]; kz=[]; ktri=[];
sx=[];sy=[];sz=[];
LButton='up';
selectedPoint=0;
%ox=[]; oy=[];
realMeshNo=((meshSize-3)*2)^2;
%basisMeshNo=((meshSize-2)*2)^2;

decompNum=0;
reconstNum=0;

% 
% data = load('data2.mat');
% % data = load('tempPadj.mat');
% data = data.data;
% % data = load ('tempPadj');

%data = load('tempPadj');
[data]=load ('tempPadj');

tri=data.TRI;
x=data.x;
y=data.y;
z=data.z;
sx=data.sx;
sy=data.sy;
sz=data.sz;

%[data.x y z]


plotInitialGraph() 

% Call back functions
%% window button motion    
    function wbm(h,evd)
        pt = get(ah1,'CurrentPoint');
        cp = pt(1,1:2);
        nz=initialZ(cp(1),cp(2));
        s = sprintf('(x,y,z)=(%2.5f,%2.5f,%2.5f)',cp(1),cp(2),nz);
        set(sth3,'String', s);
        
        if(strcmp(LButton,'down') && selectedPoint~=0)
            x(selectedPoint)=cp(1);
            y(selectedPoint)=cp(2);
            z(selectedPoint)=initialZ(cp(1),cp(2));
            if (steps==0)
                %x(selectedPoint)=cp(1);
                %y(selectedPoint)=cp(2);
            end
  %          plotMoveGraph;
        end
    end

%% window button down
    function wbd(h,evd)
        LButton='down';
        pt = get(ah1,'CurrentPoint');
        cp = pt(1,1:2);
        %s = sprintf('(x,y)=(%2.5f,%2.5f)',cp(1),cp(2));
        range=0.005;
        selectedPoint=0;
        for i=1:length(x);
            if ( x(i)<cp(1)+range && x(i)>cp(1)-range...
                && y(i)<cp(2)+range && y(i)>cp(2)-range)
                selectedPoint=i
                break;
            end
        end
    end

%% window button up
    function wbu(h,evd)
        LButton='up';
        selectedPoint=0;
    end

%% Decompositon
%     function decomposeButton_Callback(hObject,eventdata)
%         %w=[kz' ones(length(kz),1)];
%         w=[kz' P];
%         [TRI,x,y,z,kx,ky,w] = decompose2(TRI,x,y,z,kx,ky,w);
%         basisMeshNo=length(kx);
%         %basisMeshNo=((meshSize-2)*2)^2;
%         e=[ones(1,basisMeshNo) zeros(1,(length(x)-basisMeshNo))];
%         [TRI,x,y,z]=cutEdge(TRI,x,y,z,e);
% 
%         decompNum=decompNum+1;
%         str = ['Decompose = ' num2str(decompNum)];
%         set(pbh7,'String', str);
%     end

%% Call back functions
%     function edittext1_Callback(hObject,eventdata)
%         %user_string = get(hObject,'String')
%         user_entry = str2double(get(hObject,'string'));
%         if isnan(user_entry)
%             errordlg('You must enter a numeric value','Bad Input','modal')
%             return
%         else
%             if user_entry>100
%                 user_entry=100;
%                 set(eth1,'String', '100');
%             end
%             if user_entry<0
%                 user_entry=0;
%                 set(eth1,'String', '0');
%             end
%             percentage=user_entry;
%         end
%     end
% 
%     function edittext2_Callback(hObject,eventdata)
%         %user_string = get(hObject,'String')
%         user_entry = str2double(get(hObject,'string'));
%         if isnan(user_entry)
%             errordlg('You must enter a numeric value','Bad Input','modal')
%             return
%         else
%             meshSize=user_entry;
%             if meshSize<5
%                 meshSize=5;
%                 set(eth2,'String', '5');
%             end
%             realMeshNo=((meshSize-3)*2)^2;
%             plotInitialGraph(meshSize);
%             steps=0;
%             set(pbh1,'String', 'refinement steps = 0');
%         end
%         
%     end

%% refinement by each step
    function stepButton_Callback(hObject,eventdata)
         steps=steps+1;
        
%         [TRI,x,y,w,e]=refineMeshEdge(TRI,x,y,w,e);
%         %[TRI,x,y,w]=refineMesh(TRI,x,y,w);
%         z=w(:,1);
%         
%         plotGraph;
%         
         s = sprintf('refinement steps = %d',steps);
         set(pbh1,'String', s);
%         
%         N=0;
%         RMSE=0;
%         MeanError=0;
%         MaxError=0;
%         if steps==1
%             for i=1:length(sx)
%                 for j=1:length(x)
%                     if sx(i)==x(j) && sy(i)==y(j)
%                         diff=sz(i)-z(j);
%                         RMSE = diff^2+RMSE;
%                         MeanError=abs(diff)+MeanError;
%                         diff=abs(diff);
%                         if diff>MaxError
%                             MaxError=diff;
%                         end
%                         N=N+1;
%                     end
%                 end
%             end
%             N=N+realMeshNo
%             RMSE=sqrt(RMSE/N)
%             PSNR=20*log10(255/RMSE)
%             MeanError=MeanError/N
%             MaxError
%             percentage=100*realMeshNo*4/3/N
%             ratio=100/percentage
%         end


[tri,x,y,w]=testRefineTriDataNew5(tri,x,y,w);



    end

%     function resetButton_Callback(hObject,eventdata)
%         plotInitialGraph(meshSize) 
%         steps=0;
%         set(pbh1,'String', 'refinement steps = 0');
%     end

    function findPButton_Callback(hObject,eventdata)

        %         %P=findP(TRI,x,y,z,sx,sy,sz,meshSize);
        %         P=findP2(TRI,x,y,z,sx,sy,sz,meshSize);
        % %         tmp=load('kPval');
        % %         P=tmp.P;
        %         set(pbh4,'String', 'found P');
        %         %[TRI,x,y,z]=initialData(meshSize-2);
        %         basisMeshNo=(meshSize+1)^2;
        %         %basisMeshNo=((meshSize-2)*2)^2;
        %         e=[ones(1,basisMeshNo) zeros(1,(length(x)-basisMeshNo))];
        %         [TRI,x,y,z]=cutEdge(TRI,x,y,z,e);
        %         w=[z' P];
        %         plotGraph;
        %
        %         %basisMeshNo=((meshSize-3)*2)^2;
        %         basisMeshNo=(meshSize-2)^2;
        %         e=[ones(1,basisMeshNo) zeros(1,(length(x)-basisMeshNo))];

        tic;
        [A,b,utri]=makeEquations(tri,[x' y' z'],[sx' sy' sz']);
        toc
        tic;
        P=A\b;
        toc
        [junk ix] = sort(utri); % for sorting samples by triangle
        ix = [ix; ((length(ix)+1):length(b))']; % Don't forget added equations for p_i=0.
        resid = A*P-b;
        w = [z' P];
        set(pbh4,'String', 'found P');
    end

%% cut the help refinement edge
     function cutEdgeButton_Callback(hObject,eventdata)
%         % only filter cutting point connectivity
%         [TRI,tx,ty,tz]=cutEdge(TRI,x,y,z,e);
%         %TRI = delaunay(x,y);
%         trimesh(TRI,x,y,z);
%         %plotGraph;
     end
% 
     function movingButton_Callback(hObject,eventdata)
%         plotMoveGraph
     end

%% add sample data
     function addDataButton_Callback(hObject,eventdata)
% %         [sx,sy,sz]=addSampleData2(kx,ky,meshSize,1);
% %         %SXno=length(sx)
% %         i=1;
% %         while i<=length(sx)
% %             if rand > percentage/100
% %                 sx(i)=[];sy(i)=[];sz(i)=[];
% %             else
% %                 i=i+1;
% %             end
% %         end
%         [sx,sy,sz]=addSampleData3(kx,ky,data);
%         plotInitialGraph(meshSize)
%         %save sampleData kx ky kz sx sy sz;
% %         sampleData = load('sampleData.mat');
% %         kx = sampleData.kx;
% %         ky = sampleData.ky;
% %         kz = sampleData.kz;
% %         sx = sampleData.sx;
% %         sy = sampleData.sy;
% %         sz = sampleData.sz;
%         
% %         x(1:length(kx))=kx;
% %         y(1:length(ky))=ky;
% %         z(1:length(kz))=kz;
% %         z = adjustEdge(x,y,z,length(kx));
% %         w=[kz' ones(length(kz),1)];
% %         figure;
% %         trimesh(TRI,x,y,z, 'FaceAlpha',0.5);
% %         %trimesh(TRI,x,y,z);
        hold on;
         plot3(sx,sy,sz,'.');
% %         %plot3(sx,sy,sz,'or');
% %         %plot(sx,sy,'or');
% %         
% %         plot3(kx,ky,kz,'rs',...
% %             'MarkerEdgeColor','k',...
% %             'MarkerFaceColor','black',...
% %             'MarkerSize',3)
% %         
         hold off

    end
    
%% Reuse functions
    function plotInitialGraph()
        %         %[TRI,x,y,z]=initialData(meshSize);
        %         %tmp = load('data.mat');
        %         %data = tmp.data3;
                %[tri,ktri,x,y,z]=initialMesh(meshSize,data);
        %         %realMeshNo=((meshSize-3)*2)^2;
        %         realMeshNo=(meshSize+1)^2;
        %         kx=x(1:realMeshNo);
        %         ky=y(1:realMeshNo);
        %         rx=x(realMeshNo+1:length(x));
        %         ry=y(realMeshNo+1:length(y));
        %         sx=[];sy=[];sz=[];
        %         steps = 0;
        %         e=[];
        %
        %         trimesh(TRI,x,y)
        %         hold on;
        %         plot(kx,ky,'rs',...
        %             'MarkerEdgeColor','k',...
        %             'MarkerFaceColor','black',...
        %             'MarkerSize',5)
        %         plot(rx,ry,'rs',...
        %             'MarkerEdgeColor','k',...
        %             'MarkerFaceColor',[0.9,0.9,0.9],...
        %             'MarkerSize',5)
        %
        %         hold off
        %         %trimesh(TRI,x,y,z, 'FaceAlpha',0.5)
        %         set(pbh4,'String', 'find P');
        %
        % %         figure;
        % %         trimesh(ktri,kx,ky,ones(1,length(kx)));
        trimesh(tri,x,y,z, 'FaceColor','none');
        hold on
        plot3(sx,sy,sz,'.')
        hold off
        X=x; Y=y; Z=z;
        SX=sx; SY=sy; SZ=sz;
        set(pbh4,'String', 'find P');

    end

%     function plotMoveGraph
%         kx=x(1:realMeshNo);
%         ky=y(1:realMeshNo);
%         rx=x(realMeshNo+1:length(x));
%         ry=y(realMeshNo+1:length(y));
%         
%         trimesh(TRI,x,y)
%         hold on;
%         plot(kx,ky,'rs',...
%             'MarkerEdgeColor','k',...
%             'MarkerFaceColor','black',...
%             'MarkerSize',5)
%         plot(rx,ry,'rs',...
%             'MarkerEdgeColor','k',...
%             'MarkerFaceColor',[0.9,0.9,0.9],...
%             'MarkerSize',5)
%         hold off
%     end
% 
%     function plotGraph
%         trimesh(TRI,x,y,z, 'FaceAlpha',0.5);
%         %trimesh(TRI,x,y);
%         hold on;
%         %plot3(sx,sy,sz,'.');
%         %plot(sx,sy,'or');
%         hold off
% 
%     end

end
    