function [A,b,utri] = makeEquationsSnap(ktri,kv,u)
% DONT USE THIS.  Instead use
% [A,b]=makeEquations(ktri,kv,u) 
% this version is only to be identical to Wenjie's code for comparision

    maxsubdiv = 4; %%%%%%%%%%

su1 = size(u,1); % number of sample points
n = size(kv,1); % number of vertices
[ktri, tridet] = orientTriangulation(ktri, kv); % orient triangles ccw
[nb, deg] = makeClosedRings(ktri, n);

A = sparse(su1+(1:n),1:n,1,su1+n,n); % reserve space for matrix
b = zeros(su1+n,1);
utri = zeros(su1,1); % Debug check that all sample points get used.

nt = size(ktri,1); % number of triangles
for i=1:nt % loop through triangles
    t = ktri(i,:); 
    d = deg(t)'; % process if neighborhood is complete & t contains samples.
    if all(d>0) % if t's vertices have complete one-rings
        [alpha,uindex] = ptsInTri(kv(t,:), tridet(i), u); % find barycentric coords of all points in triangle (& indices)
        if ~isempty(uindex) % there are samples; we need to subdivide triangle t. ring
            
            if any(utri(uindex)>0)  % Debug check that we use each point once.
                badu = find(utri(uindex)>0);
                badu = uindex(badu)
                utri(badu)
                disp('already found vertex in triangle')
            end
            utri(uindex) = i;
            
% Our representation of a triangle is as three complete rings, with center
% vertex first, plus d, the number of vertices in the ring, plus ind, where
% ind(i) is the position of center i+1 in ring i.
            % find triangle vertices in other's rings; we'll maintain ind
            ind = [find(nb(:,t(1)) == t(2),1) ... % find t(2) in t(1)'s ring
                   find(nb(:,t(2)) == t(3),1) ... % find t(3) in t(2)'s ring
                   find(nb(:,t(3)) == t(1),1) ];  % find t(1) in t(3)'s ring

% We work with Zs and Ps for the set of unique vertices in the one-rings of
% the 3 triangle vertices. We use the z coordinates, and make a basis for
% the space of linear functions over the p's in this neighborhood. 
            [vert, junk, pperm] = unique([nb(1:d(1),t(1)); nb(1:d(2),t(2)); nb(1:d(3),t(3))]);
            nvert = size(vert,1);
            pcoeffs = [zeros(nvert,1) eye(nvert)];
            
% Debug check that vert & perm give appropriate neighbor list.
%             if any(nb(1:d(1),t(1))~=vert(pperm(1:d(1)))) ||...
%                     any(nb(1:d(2),t(2))~=vert(pperm(d(1)+(1:d(2))))) ||...
%                     any(nb(1:d(3),t(3))~=vert(pperm(d(1)+d(2)+(1:d(3)))))
%                 disp('messed up pperm for unique vertices');
%             end

            % Initialize Z,P from neighbors and degrees for ccw triangle 123
            % Z = mesh vertex z_i + 0*pvector (i is unique vertex id)
            % P = 0*z_i + 0*pvector + 1*p_i (basis pcoeffs made above)
            Z1 = [kv(nb(1:d(1),t(1)), 3) zeros(d(1), nvert)];
            Z2 = [kv(nb(1:d(2),t(2)), 3) zeros(d(2), nvert)];
            Z3 = [kv(nb(1:d(3),t(3)), 3) zeros(d(3), nvert)];
            P1 = pcoeffs(pperm(1:d(1) ),:);
            P2 = pcoeffs(pperm(d(1)+(1:d(2)) ),:);
            P3 = pcoeffs(pperm(d(1)+d(2)+(1:d(3)) ),:);

% Now, for every sample point u, we refine to find its Z coordinate as
% a constant z plus a linear function of p's in the neighborhood. 
% We then put those into the sparse matrix and let the right side be the
% deviation from sample Z to interpolated Z value.
            for jj = 1:size(alpha,1)  % for each sample, make matrix row.
                Z = refineTriSnap(alpha(jj,:), Z1, P1, Z2, P2, Z3, P3, d, ind);
                b(uindex(jj)) = u(uindex(jj),3) - Z(1); % right hand side
                A(uindex(jj), vert) = Z(2:end); % coefficients for p into place
            end
        end
    end
end

% Debug check to make sure we used every sample point
unused = find(utri==0);
if ~isempty(unused)
    disp(['Unused u vertices', num2str(unused')]);
end
