function Z = refineTriSnap(alpha, Z1, P1, Z2, P2, Z3, P3, d, ind)
% DONT USE THIS.  Instead use
% Z = refineTri(alpha, Z1, P1, Z2, P2, Z3, P3, d, ind)
% This is only to match wenjie's
maxsubdiv = 4;
% no Ztol
% nearest neighbor instead of barycentric at end.

im1 = ind-1+(d-1).*(ind<=2); % minus 1 with wrap to d before 2.
ip2 = ind+2-(d-1).*(ind>=d-1); % plus 2 with wrap to 2 after d.

% DEBUGGING ASSERTS: uncomment if you make modifications to the code
% if any(abs([Z1(ind(1),:)-Z2(1,:);  P1(ind(1),:)-P2(1,:); % check ind
%         Z2(ind(2),:)-Z3(1,:); P2(ind(2),:)-P3(1,:);
%         Z3(ind(3),:)-Z1(1,:); P3(ind(3),:)-P1(1,:)]) > 1e-12)
%     disp('incorrect center or ind found in refineTri');
% end
%
% ip1 = ind+1-(d-1).*(ind>=d);  % loc of other t vertex (debug only)
% if any(abs([Z1(ip1(1),:)-Z3(1,:);  P1(ip1(1),:)-P3(1,:); % check ind+1
%         Z2(ip1(2),:)-Z1(1,:); P2(ip1(2),:)-P1(1,:);
%         Z3(ip1(3),:)-Z2(1,:); P3(ip1(3),:)-P2(1,:)]) > 1e-12)
%     disp('incorrect center or ip1 found in refineTri');
% end

%%%%%%%%Z = alpha(1)*Z1(1,:) + alpha(2)*Z2(1,:) + alpha(3)*Z3(1,:); % barycentric interpolation

for n = 1:maxsubdiv % Max number of subdivision steps for a point (may quit early)

    % refine all three rings
    [Z1,P1] = refineOneRing(Z1,P1);
    [Z2,P2] = refineOneRing(Z2,P2);
    [Z3,P3] = refineOneRing(Z3,P3);

% DEBUGGING ASSERTS: uncomment if you make modifications to the code
% ip1 = ind+1-(d-1).*(ind>=d);  % loc of other t vertex (debug only)
%     if any(abs([Z1(ind(1),:) - Z2(ip1(2),:);  P1(ind(1),:) - P2(ip1(2),:);
%             Z2(ind(2),:) - Z3(ip1(3),:);  P2(ind(2),:) - P3(ip1(3),:);
%             Z3(ind(3),:) - Z1(ip1(1),:);  P3(ind(3),:) - P1(ip1(1),:)])>1e-12)
%         disp('Same point constructed differently in two rings')
%     end

    % Z,P for rings for new vertices, ccw from first defining point
    Z12 = [Z1(ind(1),:); Z1(1,:); Z1(im1(1),:); Z2(ip2(2),:); Z2(1,:); Z2(ind(2),:); Z3(ind(3),:)];
    Z23 = [Z2(ind(2),:); Z2(1,:); Z2(im1(2),:); Z3(ip2(3),:); Z3(1,:); Z3(ind(3),:); Z1(ind(1),:)];
    Z31 = [Z3(ind(3),:); Z3(1,:); Z3(im1(3),:); Z1(ip2(1),:); Z1(1,:); Z1(ind(1),:); Z2(ind(2),:)];
    P12 = [P1(ind(1),:); P1(1,:); P1(im1(1),:); P2(ip2(2),:); P2(1,:); P2(ind(2),:); P3(ind(3),:)];
    P23 = [P2(ind(2),:); P2(1,:); P2(im1(2),:); P3(ip2(3),:); P3(1,:); P3(ind(3),:); P1(ind(1),:)];
    P31 = [P3(ind(3),:); P3(1,:); P3(im1(3),:); P1(ip2(1),:); P1(1,:); P1(ind(1),:); P2(ind(2),:)];


    [amax, acase] = max(alpha);
    switch acase*(amax>=0.5)
        case 0 % central triangle
            alpha = 2*(alpha+alpha([2 3 1]))-1;
            % refineTri(alpha, Z12, P12, Z23, P23, Z31, P31, [6 6 6], [6 6 6]);
            Z1 = Z12;
            P1 = P12;
            Z2 = Z23;
            P2 = P23;
            Z3 = Z31;
            P3 = P31;
            d(:) = 7;
            ind(:) = 6;

        case 1 % triangle by vertex 
            alpha(1) = alpha(1)-alpha(2)-alpha(3);
            alpha(2) = 2*alpha(2);
            alpha(3) = 2*alpha(3);
            %refineTri(alpha, Z1, P1, Z12, P12, Z31, P31, [d(1) 6 6], [ind(1) 7 5]);
            Z2 = Z12;
            P2 = P12;
            d(2) = 7;
            ind(2) = 7;
            Z3 = Z31;
            P3 = P31;
            d(3) = 7;
            ind(3) = 5;

        case 2 % triangle by vertex
            alpha(2) = alpha(2)-alpha(3)-alpha(1);
            alpha(3) = 2*alpha(3);
            alpha(1) = 2*alpha(1);
            %refineTri(alpha, Z12, P12, Z2, P2, Z23, P23, [6 d(2) 6], [5 ind(2) 7]);
            Z1 = Z12;
            P1 = P12;
            d(1) = 7;
            ind(1) = 5;
            Z3 = Z23;
            P3 = P23;
            d(3) = 7;
            ind(3) = 7;

        case 3 % triangle by vertex
            alpha(3) = alpha(3)-alpha(1)-alpha(2);
            alpha(1) = 2*alpha(1);
            alpha(2) = 2*alpha(2);
            %refineTri(alpha, Z31, P31, Z23, P23, Z3, P3, [6 6 d(3)], [7 5 ind(3)]);
            Z1 = Z31;
            P1 = P31;
            d(1) = 7;
            ind(1) = 7;
            Z2 = Z23;
            P2 = P23;
            d(2) = 7;
            ind(2) = 5;
    end

    im1 = ind-1+(d-1).*(ind<=2); % minus 1 with wrap to d before 2.
    ip2 = ind+2-(d-1).*(ind>=d-1); % plus 2 with wrap to 2 after d.

    % DEBUGGING ASSERTS: uncomment if you make modifications to the code
    %
    %     if any(abs([Z1(ind(1),:)-Z2(1,:);  P1(ind(1),:)-P2(1,:); % check ind
    %             Z2(ind(2),:)-Z3(1,:); P2(ind(2),:)-P3(1,:);
    %             Z3(ind(3),:)-Z1(1,:); P3(ind(3),:)-P1(1,:)]) > 1e-12)
    %         disp('incorrect center or ind found in refineTri');
    %     end
    %
    %     ip1 = ind+1-(d-1).*(ind>=d);  % loc of other t vertex (debug only)
    %     if any(abs([Z1(ip1(1),:)-Z3(1,:);  P1(ip1(1),:)-P3(1,:); % check ind+1
    %             Z2(ip1(2),:)-Z1(1,:); P2(ip1(2),:)-P1(1,:);
    %             Z3(ip1(3),:)-Z2(1,:); P3(ip1(3),:)-P2(1,:)]) > 1e-12)
    %         disp('incorrect center or ip1 found in refineTri');
    %     end

%     Zold = Z; % check for early exit
%     Z = alpha(1)*Z1(1,:) + alpha(2)*Z2(1,:) + alpha(3)*Z3(1,:); % barycentric interpolation
%     if sum(abs(Zold-Z))<Ztol
%         break; % early exit if we are accurate
%     end
end
Z = (Z1(1,:) + Z2(1,:) + Z3(1,:))/3; % PLeastsq uses center point
