function ST=starShape(T)

%--------------------------------------------------------------------------
%
%               ST=starShape(T)
%
%   T: nx3 matrix, the connectivity matrix of a triangular mesh
%  ST: a matrix with 3m columns, where m is the number of vertices,
%      each 3-column block represents a star
%
%--------------------------------------------------------------------------

m=max(max(T));
n=size(T,1);
numFaces=zeros(1,m);

for i=1:n
   numFaces(T(i,1))=numFaces(T(i,1))+1;
   numFaces(T(i,2))=numFaces(T(i,2))+1;
   numFaces(T(i,3))=numFaces(T(i,3))+1;

   ST(numFaces(T(i,1)),3*T(i,1)-2)=T(i,1);
   ST(numFaces(T(i,1)),3*T(i,1)-1)=T(i,2);
   ST(numFaces(T(i,1)),3*T(i,1))=T(i,3);
   
   ST(numFaces(T(i,2)),3*T(i,2)-2)=T(i,1);
   ST(numFaces(T(i,2)),3*T(i,2)-1)=T(i,2);
   ST(numFaces(T(i,2)),3*T(i,2))=T(i,3);
   
   ST(numFaces(T(i,3)),3*T(i,3)-2)=T(i,1);
   ST(numFaces(T(i,3)),3*T(i,3)-1)=T(i,2);
   ST(numFaces(T(i,3)),3*T(i,3))=T(i,3);
end





